package WWWServer;

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.Class;

class HackerException extends Throwable
	{
	HackerException(String s)
		{ super(s);
		}
	}

class ServerException extends Throwable
	{
	ServerException(String s)
		{ super(s);
		}
	}

public class ConnectThread extends Thread {
	public Document document=null; //      cgi
    public Socket socket = null;
    public PrintWriter pw; // print to socket
	public BufferedReader br; // read from socket
	private boolean WaitState; //    

    ConnectThread(Socket socket) {
        super("ConnectThread");
        this.socket = socket;
		document = new Document();
		document.socket = socket;
		document.BodySize = 0;
		document.Thread = this;
		document.arg = new Properties();
		WaitState = false;
    }

public synchronized Document Wait(long w) //    
	{
//System.out.println("Wait start");
	WaitState = true;
	WWWServer.Main.SessionList.put(document.Url,this);
	document.out.flush();
	document.out.close();
	try {
	document.socket.close();
	wait(w);
	} catch (IOException e) {}
	catch (InterruptedException e)
		{
System.out.println(" wait() Interupt exception.");
		}
	notify();
//System.out.println("Wait end");
	//    
	Main.SessionList.remove(document.Url);
	if (WaitState)
		{ //   
		return null;
		}
	else return document;
	}

public synchronized void Continue() //  
	{
	WaitState = false;
	notify();
	}

public void run() //    serialize
	{ int i;
//    System.out.println("Accept connection from: "+socket.getInetAddress());
    try
		{
        document.in = br = new BufferedReader(
                  new InputStreamReader(socket.getInputStream()));
		document.out = pw = new PrintWriter(
                              new BufferedOutputStream(socket.getOutputStream(), 1024), false);
        String outputLine,s;
		document.Header = new Properties();
//        outputLine = "WWW Server listen:";
//        pw.println(outputLine);
//        pw.flush();
//	 
		try {
		s = br.readLine();
//System.out.println(s);
Main.WriteLog(socket.getInetAddress()+"\t"+s+"\t"+new Date()+"\n");
		document.Header.put("METHOD",s);
		try { // Hecker testing
		//  URL  
		i = s.indexOf(' ')+1; // 
		s = s.substring(i,s.indexOf(' ',i));
		if ((i=s.indexOf('?'))>0)
			{ //  
			s = s.substring(0,i);
			}
		if (s.indexOf("..")>=0) throw new HackerException("Danger path");
		document.Url = s;
       for(i=0; i<30;++i)
			{ String key,value,l;
			l = br.readLine();
			if (l.length() == 0) break;
			key = l.substring(0,l.indexOf(':')+1).toUpperCase();
			value = l.substring(l.indexOf(':')+2);
			document.Header.put(key,value);
//System.out.println("String:"+l+'*');
//System.out.println("Key="+key+" val="+value);
            }
			}
		catch (NullPointerException e)
			{
			System.out.println("Null exception");
			//e.printStackTrace();
			throw new HackerException("Manuaul command entering.");
			}
		catch(StringIndexOutOfBoundsException e)
			{ throw new HackerException("Format fields header error. No ':'");
			}
		if (i>=30) throw new HackerException("Too long header.");
        if (document.Header.getProperty("METHOD").startsWith("GET ")) doGetPost();
        else if (document.Header.getProperty("METHOD").startsWith("POST ")) doGetPost();
        else if (document.Header.getProperty("METHOD").startsWith("HEAD ")) doGetPost();
			}
		catch (HackerException n)
			{ //   
			Main.WriteHackerLog(socket.getInetAddress()+"\t"+new Date()+"\n");
			socket.close();
		     for (Enumeration e = document.Header.propertyNames() ; e.hasMoreElements() ;)
				{ String key = (String)e.nextElement(),val = document.Header.getProperty(key);
				Main.WriteHackerLog("\t"+key+"  "+val+"\n");
     			}
			Main.WriteHackerLog("\n");
			}
		catch ( ServerException e)
			{ //  
			Main.WriteLog("Server error: "+e.getMessage()+"\n");
			}
        }
	catch (IOException e)
		{
        e.printStackTrace();
        }
//    System.out.println("Close connection.");
	}

void GetArg(String p) throws HackerException //    document.arg
	{
try {
	int i = p.indexOf('?');
	if (i>0)
		{ //  
		String p2 = p.substring(i+1);
//System.out.println("p2="+p2+'*');
		int n=0,i2=0; //   
		String k,v;
		while((i=p2.indexOf('&'))>0)
			{
			String p3 = p2.substring(0,i);
			p2 = p2.substring(i+1);
			k = p3.substring(0,p3.indexOf('='));
			v = p3.substring(p3.indexOf('=')+1);
			document.arg.put(k,v);;
//System.out.println("param="+p3+'*');
			}
		k = p2.substring(0,p2.indexOf('='));
		v = p2.substring(p2.indexOf('=')+1);
		document.arg.put(k,v);;
//System.out.println("param="+p2+'*');
		}
} catch (Exception e) { throw new HackerException("Header format error (Argument format)");}
	}

	void doGetPost() throws HackerException,ServerException  // Process GET command
	{
	String p,h; int b;
//	BufferedOutputStream out;
	OutputStream out;
	BufferedInputStream in;
	h = document.Header.getProperty("METHOD");
	int i = h.indexOf(' ');
	if (h.indexOf(" HTTP/")<0) throw new HackerException("no HTTP field");
	try {
	p = h.substring(i+1,h.indexOf(' ',i+1));
	try { document.BodySize=Integer.parseInt(document.Header.getProperty("CONTENT-LENGTH:"));}
	catch (Exception e) {document.BodySize=0;}
	GetArg(p); //    document.arg
	if (p.startsWith(Main.CgiRoot))
    	{
       	ConnectThread t = (ConnectThread)Main.SessionList.get(document.Url);
		if (t != null)
			{ //  
//System.out.println("Found sesion!");
			t.document = document;
			t.Continue();
//System.out.println("resumed sesion!");
			}
		else
			{ //  CGI
			//  
			String ClassName;
			i = p.indexOf('?');
			if (i>0)
				{ //  
	    	    ClassName = p.substring(1,i);
				}
			else
				{ //  
        	    ClassName = p.substring(1);
				}
			i = ClassName.indexOf('.');
			if (i<0) throw new HackerException("No method name");
			String method = ClassName.substring(i+1);
			ClassName=ClassName.substring(0,i);
			ClassName=ClassName.replace('/','.');
//System.out.println("ClassName="+ClassName+ " Method="+method+'*');
			if (!p.startsWith("HEAD"))
				ExecClass(ClassName,method,document);
			else
				{
				pw.println("HTTP/1.0 200 \n");
				pw.flush();
				}
			try {
    		   	document.socket.close();
				} catch (IOException e) {};
			}
		}
	else try {
//    	out = new BufferedOutputStream(socket.getOutputStream());
    	out = socket.getOutputStream();
		try {
			if (p.charAt(p.length()-1)=='/') p = p+Main.DefaultFileName;
			File inFile = new File(Main.WwwRoot+p);
    		in = new BufferedInputStream(new FileInputStream(inFile));
			long size = inFile.length();
			pw.println("HTTP/1.0 200 ");
			if (p.lastIndexOf(".html")>0) pw.println("Content-Type: text/html");
			else if (p.lastIndexOf(".txt")>0) pw.println("Content-Type: text/plain");
			else if (p.lastIndexOf(".gif")>0) pw.println("Content-Type: image/gif");
			else  pw.println("Content-Type: application/octet-stream");
			pw.println("Content-Length: "+size);
			pw.println();
			pw.flush();
			if (!p.startsWith("HEAD"))
				while ((b = in.read()) != -1) out.write(b);
			in.close();
			out.close();
			}
		catch (FileNotFoundException e)
			{
			pw.println("HTTP/1.0 404 \n");
//        	pw.println("File: " + p+" Not found");
        	pw.println("File: " + Main.WwwRoot+p+" Not found");
    		throw new HackerException("File: " + Main.WwwRoot+p+" Not found");
			}
		pw.flush();
        document.out.flush(); document.out.close();
       	document.socket.close();
		}
	catch (IOException e)
		{
        e.printStackTrace();
		}
		}
	catch (StringIndexOutOfBoundsException e)
		{
		throw new HackerException("Header format error (String out of bounds)");
		}
	catch (NullPointerException e)
		{
		throw new HackerException("Header format error(null pointer)");
		}
	}

void ExecClass(String name,String method, Document doc) throws HackerException //    .
	{
	try {
		Class t = Class.forName(name);
//		System.out.println("Class found !");
		Class[] p = new Class[1];
		p[0] = (new Document()).getClass();
//		p[1] = (new Properties()).getClass();
		Method m = t.getDeclaredMethod(method,p);
//		Method m = t.newInstance().getDeclaredMethod("main2",p);
//		System.out.println("Method found !");
//		m.invoke(t,new Object[]{doc,arg}); // Start method main
		m.invoke(t.newInstance(),new Object[]{doc}); // Start method main
		}
    catch (InstantiationException e)
		{
		System.out.println("InstantiationException!");
   		throw new HackerException("InstantiationException");
		}
    catch (ClassNotFoundException e)
		{
		System.out.println("Class not found !");
   		throw new HackerException("Class not found !");
		}
    catch (NoSuchMethodException e)
		{
		System.out.println("Method not found !");
   		throw new HackerException("Method not found !");
		}
    catch (IllegalAccessException  e)
		{
		System.out.println("Access violation !");
   		throw new HackerException("Access violation !");
		}
    catch (IllegalArgumentException  e)
		{
		System.out.println("Arguments violation!");
   		throw new HackerException("Arguments violation!");
		}
    catch (InvocationTargetException  e)
		{
		System.out.println("Invocation exception !");
   		throw new HackerException("Invocation exception !");
		}
    catch (NullPointerException  e)
		{
		System.out.println("specified object is null.!");
   		throw new HackerException("specified object is null.!");
		}
//try {System.in.read();} catch (Exception e){}
	}
}

