package WWWServer;
/*
 
*/
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.Class;

public class Main
{
public static String WwwRoot = null; //"c:/maslov/JAVA/WWWServer";
public static String CgiRoot = "/cgi"; //    URI
public static  int WWW_PORT = 80; // Port number
//public static String ContinueURL = null; // Flag continue session
public static Hashtable SessionList = new Hashtable(); //  

public static String DefaultFileName = "index.html";	//    
public static boolean LogEnable = true;		//    
public static String LogFileName = null;	//    .    .
public static String HackerFileName = null;	//    
public static RandomAccessFile LogFile = null; // Log file stream
public static RandomAccessFile HackerFile = null; // Log file stream

public void ExecClass(String name, Document doc, String arg[]) //    .
	{
	try {
		Class t = Class.forName(name);
		System.out.println("Class found !");
		Class[] p = new Class[2];
		p[0] = (new Document()).getClass();
		p[1] = (new String[]{}).getClass();
		Method m = t.getDeclaredMethod("main",p);
		System.out.println("Method found !");
		m.invoke(t,new Object[]{doc,arg}); // Start method main
		}
    catch (ClassNotFoundException e)
		{
		System.out.println("Class not found !");
		}
    catch (NoSuchMethodException e)
		{
		System.out.println("Method not found !");
		}
    catch (IllegalAccessException  e)
		{
		System.out.println("Access violation !");
		}
    catch (IllegalArgumentException  e)
		{
		System.out.println("Arguments violation!");
		}
    catch (InvocationTargetException  e)
		{
		System.out.println("Invocation exception !");
		}
    catch (NullPointerException  e)
		{
		System.out.println("specified object is null.!");
		}
try {System.in.read();} catch (Exception e){}
	}

public static void WriteLog(String s) //   log 
	{
	if (LogEnable)
		{
		if (LogFile != null)
			{
			try {
			LogFile.writeBytes(s);
    		} catch (IOException e)
  				{
	  			System.err.println("*** Error write LogFile :"+e.getMessage()+" ***");
	  			System.exit(1);
				}
			}
		else System.out.print(s);
  		}
	}

public static void WriteHackerLog(String s) //   log 
	{
	if (HackerFile != null)
        {
		try {
		HackerFile.writeBytes(s);
    	} catch (IOException e)
  			{
  			System.err.println("*** Error write HackerFile :"+e.getMessage()+" ***");
  		System.exit(1);
  			}
		}
	else System.out.print(s);
	}

public  Main()
	{
	System.out.println("WWW Java Server. V 1.0");
//	Parameters param = new Parameters("c:/maslov/JAVA/WWWServer/config.txt");
	Parameters param = new Parameters("config.txt");
    if (param.data.containsKey("WwwRoot")) WwwRoot = new String(param.data.getProperty("WwwRoot"));
	else
    	{
		System.err.println("*** Error in config.txt \"WWWRoot\" - not found ***");
		System.exit(1);
		}
	if (param.data.containsKey("CgiRoot"))
		CgiRoot = param.data.getProperty("CgiRoot");
	if (param.data.containsKey("WwwPort"))
		WWW_PORT = Integer.parseInt(param.data.getProperty("WwwPort"));
	if (param.data.containsKey("DefaultFileName"))
		DefaultFileName = param.data.getProperty("DefaultFileName");	//    
	if (param.data.containsKey("LogEnable"))
		if (param.data.getProperty("LogEnable").toUpperCase() == "NO")
			LogEnable = false; //    
	if (param.data.containsKey("LogFile"))
		LogFileName = param.data.getProperty("LogFile") ;	//    .    .
	if (param.data.containsKey("HackerFile"))
		HackerFileName = param.data.getProperty("HackerFile");	//    
	if (LogFileName != null)
		{
		try {
		LogFile = new RandomAccessFile(LogFileName,"rw");
		LogFile.seek(LogFile.length());
	    } catch (IOException e)
			{
			System.err.println("*** Error open LogFile :"+e.getMessage()+" ***");
			System.exit(1);
			}
		}
	if (HackerFileName != null)
		{
		try {
		HackerFile = new RandomAccessFile(HackerFileName,"rw");
		HackerFile.seek(HackerFile.length());
    	} catch (IOException e)
			{
			System.err.println("*** Error open HackerFile :"+e.getMessage()+" ***");
			System.exit(1);
			}
		}
    //   
    new ServerThread().start(); //  
	try {
	if (LogFile != null) LogFile.close();
	if (HackerFile!=null) HackerFile.close();
    } catch (IOException e)
  		{
  		System.err.println("*** Error close log files :"+e.getMessage()+" ***");
  		}
//try { System.in.read(); } catch (Exception e) {};
	}

public static void main(String[] arg)
	{
	new Main();
	}
} // end class Server
